Index: drivers/net/open_eth.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/open_eth.c,v
retrieving revision 1.1
retrieving revision 1.14
diff -u -r1.1 -r1.14
--- drivers/net/open_eth.c	2 Jan 2006 18:36:38 -0000	1.1
+++ drivers/net/open_eth.c	16 Mar 2009 19:23:39 -0000	1.14
@@ -11,28 +11,11 @@
  *
  *      Copyright (C) 1999 Aplio S.A. Written by Vadim Lebedev
  *
- * Rigt now XXBUFF_PREALLOC must be used, bacause MAC does not 
- * handle unaligned buffers yet.  Also the cache inhibit calls
- * should be used some day.
- *
  */
 
 #include <linux/config.h>
 #include <linux/module.h>
 #include <linux/version.h>
-
-/*
- * Set this to zero to disable DMA code
- *
- * Note that even if DMA is turned off we still support the 'dma' and  'use_dma'
- * module options so we don't break any startup scripts.
- */
-#ifdef CONFIG_ARCH_EP9301
-#define ALLOW_DMA	0
-#else
-#define ALLOW_DMA	1
-#endif
-
 #include <linux/kernel.h>
 #include <linux/sched.h>
 #include <linux/string.h>
@@ -41,6 +24,7 @@
 #include <linux/ioport.h>
 #include <linux/interrupt.h>
 #include <linux/delay.h>
+#include <linux/init.h>
 
 #include <linux/inet.h>
 #include <linux/netdevice.h>
@@ -52,74 +36,49 @@
 #include <asm/irq.h>
 #include <asm/pgtable.h>
 #include <asm/bitops.h>
-///?#include <asm/board.h>
 
+#include <linux/mii.h>
+#include <asm-arm/arch-ep93xx/regmap.h>
 #include "open_eth.h"
 
-#include <asm-arm/arch-ep93xx/regmap.h>
-#define TS7XXX_BASE_IO	0x01E00000
 
-/*?
-#define net_device device
-#define __pa(x) (x)
-#define __va(x) (x)
-*/
 #define __clear_user(add,len) memset((add),0,(len))
-
-///? _print
 #define _print printk
-#define DEBUG 1
+#undef DEBUG
 
-#define RXBUFF_PREALLOC	1
-#define TXBUFF_PREALLOC	1
+static const char* cardname = "ts7300-openeth";
 
 /* The transmitter timeout
  */
 #define TX_TIMEOUT	(2*HZ)
 
-/* Buffer number (must be 2^n) 
+/* Buffer number
  */
-#define OETH_RXBD_NUM		8
-#define OETH_TXBD_NUM		8
-#define OETH_RXBD_NUM_MASK	(OETH_RXBD_NUM-1)
-#define OETH_TXBD_NUM_MASK	(OETH_TXBD_NUM-1)
+#define OETH_TXBD_NUM		2
+#define OETH_RXBD_NUM		3
 
 /* Buffer size 
  */
-#define OETH_RX_BUFF_SIZE	2048
-#define OETH_TX_BUFF_SIZE	2048
-
-/* How many buffers per page 
- */
-#define OETH_RX_BUFF_PPGAE	(PAGE_SIZE/OETH_RX_BUFF_SIZE)
-#define OETH_TX_BUFF_PPGAE	(PAGE_SIZE/OETH_TX_BUFF_SIZE)
+#define OETH_TX_BUFF_SIZE	OETH_MAXBUF_LEN
+#define OETH_RX_BUFF_SIZE	OETH_MAXBUF_LEN
 
-/* How many pages is needed for buffers 
- */
-#define OETH_RX_BUFF_PAGE_NUM	(OETH_RXBD_NUM/OETH_RX_BUFF_PPGAE)
-#define OETH_TX_BUFF_PAGE_NUM	(OETH_TXBD_NUM/OETH_TX_BUFF_PPGAE)
-
-/* Buffer size  (if not XXBUF_PREALLOC 
- */
-#define MAX_FRAME_SIZE		1518
 
 /* The buffer descriptors track the ring buffers.   
  */
 struct oeth_private {
-	struct	sk_buff* rx_skbuff[OETH_RXBD_NUM];
-	struct	sk_buff* tx_skbuff[OETH_TXBD_NUM];
-
-	ushort	tx_next;			/* Next buffer to be sent */
-	ushort	tx_last;			/* Next buffer to be checked if packet sent */
-	ushort	tx_full;			/* Buffer ring fuul indicator */
-	ushort	rx_cur;				/* Next buffer to be checked if packet received */
+	volatile int	tx_head;			/* TX FIFO head*/
+	volatile int	tx_tail;			/* TX FIFO tail*/
+	volatile int	tx_goingfull;			/* TX FIFO full/empty indicator for when head == tail*/
+	volatile int	tx_lock;
+	volatile int	txq_stopped;			/* TX halted temporarily */
+	volatile int	rx_cur;				/* Next buffer to be checked if packet received */
 
 	oeth_regs	*regs;			/* Address of controller registers. */
-	oeth_bd		*rx_bd_base;		/* Address of Rx BDs. */
-	oeth_bd		*tx_bd_base;		/* Address of Tx BDs. */
+	oeth_bd		*rx_bd_base;	/* Address of Rx BDs. */
+	oeth_bd		*tx_bd_base;	/* Address of Tx BDs. */
 
 	struct net_device_stats stats;
-	///? struct enet_statistics stats;
+	struct mii_if_info mii_if;
 };
 
 static int oeth_open(struct net_device *dev);
@@ -129,80 +88,210 @@
 static void oeth_interrupt(int irq, void *dev_id, struct pt_regs *regs);
 static int oeth_close(struct net_device *dev);
 static struct net_device_stats *oeth_get_stats(struct net_device *dev);
-///?static struct enet_statistics *oeth_get_stats(struct net_device *dev);
 static void oeth_set_multicast_list(struct net_device *dev);
 static int oeth_set_mac_add(struct net_device *dev, void *addr);
 static int calc_crc(char *mac_addr);
 
-unsigned long getmappedaddr(unsigned long address);
-void write_reg(unsigned long data, unsigned long address);
-unsigned long read_reg(unsigned long address);
-
-/* __PHX__ fixme for more ehternet drivers */
-#ifdef CONFIG_OETH_UNKNOWN_TX_NEXT
-static int tx_next = -1;
+static int mdio_read(struct net_device *dev, int phy_id, int reg)
+{
+	oeth_regs *regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
+	u32 timeout;
+	int rxdata;
+
+	timeout = 10;
+	while (regs->miistatus & OETH_MIISTATUS_BUSY) {
+		mdelay(1);
+		if (--timeout < 0) {
+			printk(KERN_ERR "%s: read_MII busy timeout!!\n", dev->name);
+			return -1;
+		}
+	} 
+
+	regs->miiaddress = (((reg<<8)&OETH_MIIADDRESS_RGAD) | (phy_id&OETH_MIIADDRESS_FIAD)); 
+	regs->miicommand = OETH_MIICOMMAND_RSTAT;
+
+	timeout = 10;
+	do {
+		mdelay(1);
+		if (--timeout < 0) {
+			printk(KERN_ERR "%s: mdio_read busy timeout!!\n", dev->name);
+			return -1;
+		}
+	} while (regs->miistatus & OETH_MIISTATUS_BUSY);
+
+	rxdata = (int)regs->miirx_data;
+
+#if DEBUG
+	printk("%s: mdio_read: miiaddress 0x%x rxdata 0x%x\n", dev->name, regs->miiaddress, rxdata);
 #endif
+	
+	return rxdata;
+}
+
+static void mdio_write(struct net_device *dev, int phy_id, int reg, int value)
+{
+	oeth_regs *regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
+	u32 timeout;
+
+	timeout = 10;
+	while (regs->miistatus & OETH_MIISTATUS_BUSY) {
+		mdelay(1);
+		if (--timeout < 0) {
+			printk(KERN_ERR "%s: mdio_write busy timeout!!\n", dev->name);
+			return;
+		}
+	} 
+
+	regs->miiaddress = (((reg<<8)&OETH_MIIADDRESS_RGAD) | (phy_id&OETH_MIIADDRESS_FIAD)); 
+	regs->miitx_data = value;
+	regs->miicommand = OETH_MIICOMMAND_WCTRLDATA;
+	
+	timeout = 10;
+	do {
+		mdelay(1);
+		if (--timeout < 0) {
+			printk(KERN_ERR "%s: mdio_write busy timeout!!\n", dev->name);
+			return;
+		}
+	} while (regs->miistatus & OETH_MIISTATUS_BUSY);
+
+#if DEBUG
+	printk("%s: mdio_write: miiaddress 0x%x txdata 0x%x\n", dev->name, regs->miiaddress, value);
+#endif
+	
+}
+
+int ks8721_reset(struct net_device *dev, int phy_addr)
+{
+	s16 mii_control, timeout;
+	
+	mii_control = mdio_read(dev, phy_addr, MII_BMCR);
+	mdio_write(dev, phy_addr, MII_BMCR, mii_control | BMCR_RESET);
+	for (timeout = 1000; timeout > 0; --timeout) {
+		mdelay(1);
+		mii_control = mdio_read(dev, phy_addr, MII_BMCR);
+		if ((mii_control & BMCR_RESET) == 0)
+			break;
+	}
+	if (mii_control & BMCR_RESET) {
+		printk(KERN_ERR "%s PHY reset timeout BMCR:0x%08x!\n", dev->name, mii_control);
+		return -1;
+	}
+	return 0;
+}
+
+int ks8721_init(struct net_device *dev, int phy_addr)
+{
+	s16 data;
+	
+	/* Stop auto-negotiation */
+	data = mdio_read(dev, phy_addr, MII_BMCR);
+	mdio_write(dev, phy_addr, MII_BMCR, data & ~BMCR_ANENABLE);
+
+	/* Set advertisement to 10/100 and Half/Full duplex (full capabilities) */
+	data = mdio_read(dev, phy_addr, MII_ADVERTISE);
+	data |= ADVERTISE_CSMA | ADVERTISE_100HALF | ADVERTISE_100FULL | ADVERTISE_10FULL | ADVERTISE_10HALF;
+	mdio_write(dev, phy_addr, MII_ADVERTISE, data);
+	
+	/* Restart auto-negotiation */
+	data = mdio_read(dev, phy_addr, MII_BMCR);
+	data |= BMCR_ANRESTART | BMCR_ANENABLE;
+	mdio_write(dev, phy_addr, MII_BMCR, data);
+
+	return 0;
+}
 
 #if DEBUG
 static void
 oeth_print_packet(unsigned long add, int len)
+{	
+	int i;
+	unsigned int *buf = (unsigned int *)add;
+	int n = len / 4 + ((len & 0x3) ? 1 : 0);
+
+	_print("ipacket: add = %lx len = %d\n", add, len);
+	for(i = 0; i < n; i++) {
+  		if(!(i % 4))
+    			_print("\n");
+  		_print(" %.8x", buf[i]);
+	}
+	_print("\n");
+}
+
+static void
+oeth_print_packet_bytes(unsigned long add, int len)
 {
 	int i;
+	unsigned char *buf = (unsigned char *)add;
 
 	_print("ipacket: add = %lx len = %d\n", add, len);
 	for(i = 0; i < len; i++) {
   		if(!(i % 16))
     			_print("\n");
-  		_print(" %.2x", *(((unsigned char *)add) + i));
+  		_print(" %.2x", buf[i]);
 	}
 	_print("\n");
 }
 #endif
 
-static int
-oeth_open(struct net_device *dev)
+static void oeth2cpu_memcpy(unsigned char *dest, unsigned int *src, int nbytes)
 {
+	unsigned int dat;
 
-	oeth_regs *regs = (oeth_regs *)dev->base_addr;
-
-	struct oeth_private *cep = (struct oeth_private *)dev->priv;
-#ifdef CONFIG_OETH_UNKNOWN_TX_NEXT
-        if (tx_next != -1) {
-                cep->tx_next = tx_next;
-        }
-#endif
-
-#ifndef RXBUFF_PREALLOC
-	struct  sk_buff *skb;
-	volatile oeth_bd *rx_bd;
-	int i;
-
-	rx_bd = cep->rx_bd_base;
-
-	for(i = 0; i < OETH_RXBD_NUM; i++) {
-
-		skb = dev_alloc_skb(MAX_FRAME_SIZE);
-
-		if (skb == NULL)
-			rx_bd[i].len_status = (0 << 16) | OETH_RX_BD_IRQ;
-		else
-			rx_bd[i].len_status = (0 << 16) | OETH_RX_BD_EMPTY | OETH_RX_BD_IRQ;
+	// XXX: memcpy() can't be used because it uses the load/store multiple opcodes
+	// which asynchronously change the address of the ep93xx SMC without 
+	// initiating another cycle by toggling the read strobe.  --joff
+	while(nbytes > 0) {
+		dat = *(src++);
+		*(unsigned int *)(dest) = dat;
+		nbytes -= 4;
+		dest += 4;
+	}
+}
 
-		cep->rx_skbuff[i] = skb;
+static void cpu2oeth_memcpy(unsigned int *dest, unsigned char *src, int nbytes)
+{
+	unsigned int dat, i;
+	// supposedly we can be guaranteed of at least 16-bit alignment
+	unsigned short *src16 = (unsigned short *)src;
 
-		rx_bd[i].addr = (unsigned long)skb->tail;
+	while(nbytes > 0) {
+		dat = *(src16++);
+		dat |= *(src16++) << 16;
+		*(dest++) = dat;
+		nbytes -= 4;
 	}
-	rx_bd[OETH_RXBD_NUM - 1].len_status |= OETH_RX_BD_WRAP;
-#endif
+}
+
+static int
+oeth_open(struct net_device *dev)
+{
+	struct oeth_private *cep = (struct oeth_private *)dev->priv;
+	oeth_regs *regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
+	u32 timeout;
+	int ret;
+
+	timeout = 1000;
+	while (timeout-- && 
+	  !(mdio_read(dev, cep->mii_if.phy_id, MII_BMSR) & BMSR_ANEGCOMPLETE))
+		mdelay(1);
+
+	if (!(mdio_read(dev, cep->mii_if.phy_id, MII_BMSR)&BMSR_ANEGCOMPLETE) )
+		printk(KERN_ERR "%s BMSR_ANEGCOMPLETE timeout !\n", dev->name);
+	else if (mdio_read(dev, cep->mii_if.phy_id, MII_LPA)&LPA_DUPLEX)
+		regs->moder |= OETH_MODER_FULLD;
 
 	/* Install our interrupt handler.
 	 */
-	request_irq(IRQ_ETH_0, oeth_interrupt, 0, "eth", (void *)dev);
-
+	ret = request_irq(IRQ_ETH_0, oeth_interrupt, SA_SHIRQ, cardname, (void *)dev);
+	if (0 != ret) {
+		printk("Unable to allocate IRQ %d\n",IRQ_ETH_0);
+		return ret;
+        }
 	/* Enable receiver and transmiter 
 	 */
-	write_reg(read_reg(regs->moder) | OETH_MODER_RXEN | OETH_MODER_TXEN, regs->moder);
-
+	regs->moder |= OETH_MODER_RXEN | OETH_MODER_TXEN;
+	
 	return 0;
 }
 
@@ -210,7 +299,7 @@
 oeth_close(struct net_device *dev)
 {
 	struct oeth_private *cep = (struct oeth_private *)dev->priv;
-	oeth_regs *regs = (oeth_regs *)dev->base_addr;
+	oeth_regs *regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
 	volatile oeth_bd *bdp;
 	int i;
 
@@ -219,8 +308,8 @@
 	free_irq(IRQ_ETH_0, (void *)dev);
 
 	/* Disable receiver and transmitesr 
-	 *////?w
-	write_reg(read_reg(regs->moder) &  ~(OETH_MODER_RXEN | OETH_MODER_TXEN), regs->moder);
+	 */
+	regs->moder &= ~(OETH_MODER_RXEN | OETH_MODER_TXEN);	
 
 	bdp = cep->rx_bd_base;
 	for (i = 0; i < OETH_RXBD_NUM; i++) {
@@ -234,31 +323,6 @@
 		bdp++;
 	}
 
-#ifndef RXBUFF_PREALLOC
-
-	/* Free all alocated rx buffers 
-	 */
-	for (i = 0; i < OETH_RXBD_NUM; i++) {
-	
-		if (cep->rx_skbuff[i] != NULL)
-			dev_kfree_skb(cep->rx_skbuff[i], FREE_READ);
-		
-	}
-#endif
-#ifndef TXBUFF_PREALLOC
-
-	/* Free all alocated tx buffers 
-	 */
-	for (i = 0; i < OETH_TXBD_NUM; i++) {
-	
-		if (cep->tx_skbuff[i] != NULL)
-			dev_kfree_skb(cep->tx_skbuff[i], FREE_WRITE);
-	}
-#endif
-
-#ifdef CONFIG_OETH_UNKNOWN_TX_NEXT      
-        tx_next = cep->tx_next;
-#endif
 	return 0;
 }
 
@@ -266,77 +330,69 @@
 oeth_start_xmit(struct sk_buff *skb, struct net_device *dev)
 {
 	struct oeth_private *cep = (struct oeth_private *)dev->priv;
+	oeth_regs *regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
 	volatile oeth_bd *bdp;
-	unsigned long flags;
-
-	/* Fill in a Tx ring entry 
-	 */
-	bdp = cep->tx_bd_base + cep->tx_next;
+	unsigned int len_status;
 
-	if (cep->tx_full) {
+	cep->tx_lock = 1;
 
-		/* All transmit buffers are full.  Bail out.
-		 */
-		printk("%s: tx queue full!.\n", dev->name);
+	if ((cep->tx_head == cep->tx_tail) && cep->tx_goingfull) {
+		netif_stop_queue(dev);
+		cep->txq_stopped = 1;
+		if (cep->tx_lock == 0) oeth_tx(dev);
+		else cep->tx_lock = 0;
 		return 1;
 	}
 
+	/* Fill in a Tx ring entry 
+	 */
+	bdp = cep->tx_bd_base + cep->tx_tail;
+
 	/* Clear all of the status flags.
 	 */
-	bdp->len_status &= ~OETH_TX_BD_STATS;
+	len_status = bdp->len_status;
+	len_status &= ~OETH_TX_BD_STATS;
 
 	/* If the frame is short, tell CPM to pad it.
 	 */
 	if (skb->len <= ETH_ZLEN)
-		bdp->len_status |= OETH_TX_BD_PAD;
+		len_status |= OETH_TX_BD_PAD;
 	else
-		bdp->len_status &= ~OETH_TX_BD_PAD;
-
-#if DEBUG
-	_print("TX\n");
-	oeth_print_packet(skb->data, skb->len);
-#endif
-
-#ifdef TXBUFF_PREALLOC
+		len_status &= ~OETH_TX_BD_PAD;
 
 	/* Copy data in preallocated buffer */
 	if (skb->len > OETH_TX_BUFF_SIZE) {
 		printk("%s: tx frame too long!.\n", dev->name);
-		return 1;
+		if (cep->tx_lock == 0) oeth_tx(dev);
+		else cep->tx_lock = 0;
+		return 1; //?
 	}
 	else
-		memcpy((unsigned char *)bdp->addr, skb->data, skb->len);
+		cpu2oeth_memcpy((int *)(dev->base_addr + bdp->addr), skb->data, skb->len);
 
-	bdp->len_status = (bdp->len_status & 0x0000ffff) | (skb->len << 16);
+#if DEBUG
+	_print("TX\n");
+	oeth_print_packet((unsigned long)(dev->base_addr + bdp->addr), skb->len);
+	oeth_print_packet_bytes((unsigned long)(skb->data), skb->len);
+#endif
+	len_status = (len_status & 0x0000ffff) | (skb->len << 16);
 
-	///?dev_kfree_skb(skb, FREE_WRITE);
 	dev_kfree_skb(skb);
-#else
-	/* Set buffer length and buffer pointer.
-	 */
-	bdp->len_status = (bdp->len_status & 0x0000ffff) | (skb->len << 16);
-	bdp->addr = (uint)__pa(skb->data);
 
-	/* Save skb pointer.
-	 */
-	cep->tx_skbuff[cep->tx_next] = skb;
-#endif
-
-	cep->tx_next = (cep->tx_next + 1) & OETH_TXBD_NUM_MASK;
-	
-	save_flags(flags); cli();
+	if ((cep->tx_tail == cep->tx_head) && !cep->tx_goingfull) 
+		regs->moder |= OETH_MODER_TXEN;
 
-	if (cep->tx_next == cep->tx_last)
-		cep->tx_full = 1;
+	cep->tx_tail = (cep->tx_tail+1 == OETH_TXBD_NUM) ? 0 : (cep->tx_tail+1);
+	cep->tx_goingfull = 1;
 
 	/* Send it on its way.  Tell controller its ready, interrupt when done,
 	 * and to put the CRC on the end.
 	 */
-	bdp->len_status |= (OETH_TX_BD_READY | OETH_TX_BD_IRQ | OETH_TX_BD_CRC);
-
-	dev->trans_start = jiffies;
+	len_status |= (OETH_TX_BD_READY | OETH_TX_BD_IRQ | OETH_TX_BD_CRC);
+	bdp->len_status = len_status;
 
-	restore_flags(flags);
+	if (cep->tx_lock == 0) oeth_tx(dev);
+	else cep->tx_lock = 0;
 
 	return 0;
 }
@@ -348,33 +404,42 @@
 {
 	struct	net_device *dev = dev_id;
 	volatile struct	oeth_private *cep;
-	uint	int_events;
+	uint int_events;
 
 	cep = (struct oeth_private *)dev->priv;
 
 	/* Get the interrupt events that caused us to be here.
 	 */
-	int_events = read_reg(cep->regs->int_src);
-	write_reg(int_events, cep->regs->int_src);
+	int_events = cep->regs->int_src;
+
+#if DEBUG
+	printk("%s: interrupt handler: int_events = 0x%x\n", dev->name, int_events);
+#endif
+	/* Check for receive busy, i.e. packets coming but no place to
+	 * put them. 
+	 */
+
+	if (int_events & OETH_INT_BUSY) {
+		cep->regs->moder &= ~OETH_MODER_RXEN;
+		oeth_rx(dev_id);
+		cep->regs->moder |= OETH_MODER_RXEN;
+		cep->rx_cur = 0;
+	} else
+	
 
 	/* Handle receive event in its own function.
 	 */
 	if (int_events & (OETH_INT_RXF | OETH_INT_RXE))
 		oeth_rx(dev_id);
 
+	cep->regs->int_src = OETH_INT_BUSY | OETH_INT_RXE | OETH_INT_RXF;	
+
 	/* Handle transmit event in its own function.
 	 */
 	if (int_events & (OETH_INT_TXB | OETH_INT_TXE)) {
-		oeth_tx(dev_id);
-	    ///?mark_bh(NET_BH);
-	}
-
-	/* Check for receive busy, i.e. packets coming but no place to
-	 * put them. 
-	 */
-	if (int_events & OETH_INT_BUSY) {
-		if (!(int_events & (OETH_INT_RXF | OETH_INT_RXE)))
-			oeth_rx(dev_id);
+		if (cep->tx_lock) cep->tx_lock = 0;
+		else oeth_tx(dev_id);
+		cep->regs->int_src = OETH_INT_TXB | OETH_INT_TXE;	
 	}
 
 	return;
@@ -386,47 +451,33 @@
 {
 	struct	oeth_private *cep;
 	volatile oeth_bd *bdp;
-
-#ifndef TXBUFF_PREALLOC
-	struct	sk_buff *skb;
-#endif
+	unsigned int len_status;
 
 	cep = (struct oeth_private *)dev->priv;
 
-	for (;; cep->tx_last = (cep->tx_last + 1) & OETH_TXBD_NUM_MASK) {
+	for (;; cep->tx_head = (cep->tx_head+1 == OETH_TXBD_NUM) ? 0 : (cep->tx_head+1)) {
 
-		bdp = cep->tx_bd_base + cep->tx_last;
+		bdp = cep->tx_bd_base + cep->tx_head;
 
-		if ((bdp->len_status & OETH_TX_BD_READY) || 
-			((cep->tx_last == cep->tx_next) && !cep->tx_full))
+		// disable transmitter if empty
+		if ((cep->tx_tail == cep->tx_head) && !cep->tx_goingfull) {
+			cep->regs->moder &= ~OETH_MODER_TXEN;
+			cep->tx_head = cep->tx_tail = 0;
 			break;
+		}
+
+		len_status = bdp->len_status;
+		if (len_status & OETH_TX_BD_READY) break;
 
 		/* Check status for errors
 		 */
-		if (bdp->len_status & OETH_TX_BD_LATECOL)
-			cep->stats.tx_window_errors++;
-		if (bdp->len_status & OETH_TX_BD_RETLIM)
-			cep->stats.tx_aborted_errors++;
-		if (bdp->len_status & OETH_TX_BD_UNDERRUN)
-			cep->stats.tx_fifo_errors++;
-		if (bdp->len_status & OETH_TX_BD_CARRIER)
-			cep->stats.tx_carrier_errors++;
-		if (bdp->len_status & (OETH_TX_BD_LATECOL | OETH_TX_BD_RETLIM | OETH_TX_BD_UNDERRUN))
+		if (len_status & OETH_TX_BD_STATS)
 			cep->stats.tx_errors++;
 
 		cep->stats.tx_packets++;
-		cep->stats.collisions += (bdp->len_status >> 4) & 0x000f;
 
-#ifndef TXBUFF_PREALLOC
-		skb = cep->tx_skbuff[cep->tx_last];
-
-		/* Free the sk buffer associated with this last transmit.
-		*/
-		dev_kfree_skb(skb, FREE_WRITE);
-#endif
-
-		if (cep->tx_full)
-			cep->tx_full = 0;
+		if (cep->txq_stopped) netif_wake_queue(dev);
+		cep->txq_stopped = cep->tx_goingfull = 0;
 	}
 }
 
@@ -436,152 +487,66 @@
 	struct	oeth_private *cep;
 	volatile oeth_bd *bdp;
 	struct	sk_buff *skb;
-	int	pkt_len;
-	int	bad = 0;
-#ifndef RXBUFF_PREALLOC
-	struct	sk_buff *small_skb;
-#endif
+	int	pkt_len, len_status;
 
 	cep = (struct oeth_private *)dev->priv;
 
+#if DEBUG
+	printk("%s: oeth_rx call: rxcur 0x%x\n", dev->name, cep->rx_cur);
+#endif
+
 	/* First, grab all of the stats for the incoming packet.
 	 * These get messed up if we get called due to a busy condition.
 	 */
-	for (;;cep->rx_cur = (cep->rx_cur + 1) & OETH_RXBD_NUM_MASK) {
+	for (;; cep->rx_cur = (cep->rx_cur+1 == OETH_RXBD_NUM) ? 0 : (cep->rx_cur+1)) {
 
 		bdp = cep->rx_bd_base + cep->rx_cur;
 
-#ifndef RXBUFF_PREALLOC
-		skb = cep->rx_skbuff[cep->rx_cur];
-
-		if (skb == NULL) {
-
-			skb = dev_alloc_skb(MAX_FRAME_SIZE);
+#if DEBUG
+		printk("%s: oeth_rx loop: bdp 0x%x len_stat 0x%x rx_cur 0x%x\n", dev->name, bdp, bdp->len_status, cep->rx_cur);
+#endif
 
-			if (skb != NULL)
-			{
-				bdp->addr = (unsigned long) skb->tail;
-				bdp->len_status |= OETH_RX_BD_EMPTY;
-			}
+		len_status = bdp->len_status;
 
-			continue;
-		}
-#endif
-			
-		if (bdp->len_status & OETH_RX_BD_EMPTY)
+		if (len_status & OETH_RX_BD_EMPTY)
 			break;
 			
-		/* Check status for errors.
-		 */
-		if (bdp->len_status & (OETH_RX_BD_TOOLONG | OETH_RX_BD_SHORT)) {
-			cep->stats.rx_length_errors++;
-			bad = 1;
-		}
-		if (bdp->len_status & OETH_RX_BD_DRIBBLE) {
-			cep->stats.rx_frame_errors++;
-			bad = 1;
-		}
-		if (bdp->len_status & OETH_RX_BD_CRCERR) {
-			cep->stats.rx_crc_errors++;
-			bad = 1;
-		}
-		if (bdp->len_status & OETH_RX_BD_OVERRUN) {
-			cep->stats.rx_crc_errors++;
-			bad = 1;
-		}
-		if (bdp->len_status & OETH_RX_BD_MISS) {
-
-		}
-		if (bdp->len_status & OETH_RX_BD_LATECOL) {
-			cep->stats.rx_frame_errors++;
-			bad = 1;
-		}
-		
 		
-		if (bad) {
-
-			bdp->len_status &= ~OETH_RX_BD_STATS;
-      bdp->len_status |= OETH_RX_BD_EMPTY;
+		if (len_status & OETH_RX_BD_STATS) {
+			len_status &= ~OETH_RX_BD_STATS;
+      			len_status |= OETH_RX_BD_EMPTY;
+			bdp->len_status = len_status;
 
 			continue;
 		}
 
 		/* Process the incoming frame.
 		 */
-		pkt_len = bdp->len_status >> 16;
+		pkt_len = len_status >> 16;
         
-#ifdef RXBUFF_PREALLOC
-		skb = dev_alloc_skb(pkt_len);
+		skb = dev_alloc_skb(pkt_len + 5);
         
 		if (skb == NULL) {
 			printk("%s: Memory squeeze, dropping packet.\n", dev->name);
 			cep->stats.rx_dropped++;
 		}
 		else {
+			skb_reserve(skb, 2);   /*odd 16 bit alignment to make protocal stack happy*/
 			skb->dev = dev;
+			oeth2cpu_memcpy(skb_put(skb, pkt_len), (unsigned int *)(dev->base_addr + bdp->addr), pkt_len);
 #if DEBUG
 			_print("RX\n");
-			oeth_print_packet(bdp->addr, pkt_len);
+			oeth_print_packet((unsigned long)(dev->base_addr + bdp->addr), pkt_len);
+			oeth_print_packet_bytes((unsigned long)(skb->data), skb->len);
 #endif
-			memcpy(skb_put(skb, pkt_len), (unsigned char *)__va(bdp->addr), pkt_len);
 			skb->protocol = eth_type_trans(skb,dev);
 			netif_rx(skb);
 			cep->stats.rx_packets++;
 		}
 
-		bdp->len_status &= ~OETH_RX_BD_STATS;
-		bdp->len_status |= OETH_RX_BD_EMPTY;
-#else
-
-		if (pkt_len < 128) {
-
-			small_skb = dev_alloc_skb(pkt_len);
-
-			if (small_skb) {
-				small_skb->dev = dev;
-#if DEBUG
-				_print("RX short\n");
-                                oeth_print_packet(bdp->addr, bdp->len_status >> 16);
-#endif
-                                memcpy(skb_put(small_skb, pkt_len), (unsigned char *)__va(bdp->addr), pkt_len);
-                                small_skb->protocol = eth_type_trans(small_skb,dev);
-                                netif_rx(small_skb);
-				cep->stats.rx_packets++;
-			}
-			else {
-				printk("%s: Memory squeeze, dropping packet.\n", dev->name);
-	                        cep->stats.rx_dropped++;
-			}
-
-			bdp->len_status &= ~OETH_RX_BD_STATS;
-			bdp->len_status |= OETH_RX_BD_EMPTY;
-		}
-		else {
-        		skb->dev = dev;
-			skb_put(skb, bdp->len_status >> 16);
-			skb->protocol = eth_type_trans(skb,dev);
-			netif_rx(skb);
-			cep->stats.rx_packets++;
-#if DEBUG
-			_print("RX long\n");
-                        oeth_print_packet(bdp->addr, bdp->len_status >> 16);
-#endif
-		
-			skb = dev_alloc_skb(MAX_FRAME_SIZE);
-
-			bdp->len_status &= ~OETH_RX_BD_STATS;
-        
-			if (skb) {
-				cep->rx_skbuff[cep->rx_cur] = skb;
-
-				bdp->addr = (unsigned long)skb->tail;
-				bdp->len_status |= OETH_RX_BD_EMPTY;
-			}
-			else {
-				cep->rx_skbuff[cep->rx_cur] = NULL;	
-			}
-		}
-#endif
+		len_status &= ~OETH_RX_BD_STATS;
+		len_status |= OETH_RX_BD_EMPTY;
+		bdp->len_status = len_status;
 	}
 }
 
@@ -592,11 +557,9 @@
 }
 
 static struct net_device_stats *oeth_get_stats(struct net_device *dev)
-///?static struct enet_statistics *oeth_get_stats(struct net_device *dev)
 {
-        struct oeth_private *cep = (struct oeth_private *)dev->priv;
- 
-        return &cep->stats;
+	struct oeth_private *cep = (struct oeth_private *)dev->priv;
+	return &cep->stats;
 }
 
 static void oeth_set_multicast_list(struct net_device *dev)
@@ -610,32 +573,31 @@
 
 	/* Get pointer of controller registers.
 	 */
-	regs = (oeth_regs *)dev->base_addr;
+	regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
 
 	if (dev->flags & IFF_PROMISC) {
 	  
 		/* Log any net taps. 
 		 */
-		printk("%s: Promiscuous mode enabled.\n", dev->name);
-		write_reg(read_reg(regs->moder) | OETH_MODER_PRO, regs->moder);
+		regs->moder |= OETH_MODER_PRO;
 	} else {
 
-		write_reg(read_reg(regs->moder) & ~OETH_MODER_PRO, regs->moder);
-
+		regs->moder &= ~OETH_MODER_PRO;
+		
 		if (dev->flags & IFF_ALLMULTI) {
 
 			/* Catch all multicast addresses, so set the
 			 * filter to all 1's.
 			 */
-			write_reg(0xffffffff, regs->hash_addr0);
-			write_reg(0xffffffff, regs->hash_addr1);
+			regs->hash_addr0 = 0xffffffff;
+			regs->hash_addr1 = 0xffffffff;
 		}
 		else if (dev->mc_count) {
 
 			/* Clear filter and add the addresses in the list.
 			 */
-			write_reg(0x00000000, regs->hash_addr0);
-			write_reg(0x00000000, regs->hash_addr1);
+			regs->hash_addr0 = 0x00000000;
+			regs->hash_addr0 = 0x00000000;
 
 			dmi = dev->mc_list;
 
@@ -650,9 +612,10 @@
 
 				hash_b = calc_crc(dmi->dmi_addr); 
 				if(hash_b >= 32)
-					write_reg(read_reg(regs->hash_addr1) | 1 << (hash_b - 32), regs->hash_addr1);
+					regs->hash_addr1 |= 1 << (hash_b - 32);
 				else
-					write_reg(read_reg(regs->hash_addr0) | 1 << hash_b, regs->hash_addr0);
+					regs->hash_addr0 |= 1 << hash_b;
+					
 			}
 		}
 	}
@@ -663,30 +626,31 @@
 	struct sockaddr *addr=p;
 	volatile oeth_regs *regs;
 
-	memcpy(dev->dev_addr, addr->sa_data,dev->addr_len);
+	memcpy(dev->dev_addr, addr->sa_data, dev->addr_len);
 
-	regs = (oeth_regs *)dev->base_addr;
+	regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
 
-	write_reg(addr->sa_data[0] << 8	| addr->sa_data[1], regs->mac_addr1);
-	write_reg(addr->sa_data[2] << 24 | addr->sa_data[3] << 16 | addr->sa_data[4] << 8 	| 
-				addr->sa_data[5], regs->mac_addr0);
-	
+	regs->mac_addr1 = addr->sa_data[0] << 8 | 
+		addr->sa_data[1];
+    regs->mac_addr0 = 	addr->sa_data[2] << 24 	| 
+		addr->sa_data[3] << 16 	| 
+		addr->sa_data[4] << 8 	| 
+		addr->sa_data[5];		
+		
 	return 0;
 }
 
 /* Initialize the Open Ethernet MAC.
  */
-int oeth_probe(struct net_device *dev)
+static int __init oeth_probe(struct net_device *dev)
 {
 	struct oeth_private *cep;
 	volatile oeth_regs *regs;
 	volatile oeth_bd *tx_bd, *rx_bd;
-	int i, j, k;
-#ifdef SRAM_BUFF
-	unsigned long mem_addr = SRAM_BUFF_BASE;
-#else
+	int i;
 	unsigned long mem_addr;
-#endif
+
+	SET_MODULE_OWNER(dev);
 
 	cep = (struct oeth_private *)dev->priv;
 
